package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Noble
// Camp: Civilians

class Noble extends Civilian {
	def static order = 11;
	def static strings = Civilian.strings.attachBundle("roles/Noble.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = true;		// All roles must define own "bite" property.
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Noble(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 25;
	}
	// Update priority
	// Returns under 0: target -> it
	// Returns over 0 : it -> target
	def getUpdatePriority(target) {
		if(target.roleIs(new Slave())) {
			return 1;
		} else {
			return 0;
		}
	}
	def getRoleName() {
		return strings.getString("noble");
	}
	// When the actor is killed.
	def killed(state) {
		if(state != State.executed) {
			if(state == State.bitten) {
				def actors = JinroGame.getActors();
				def lives = actors.findAll { it.isLive() && it.name != name && it.roleIs(new Slave()) };
				if(lives) {
					lives.each {
						it.nextstate = State.sacrifice;
						it.countdown = 1;
					}
					return;
				}
			}
			noticeKilled(strings.getString("notice.killed.normal", name));
		}
		this.state = state;
		JinroGame.addHistory(this);
	}
}
